//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Expression.h"
#include "IteratorString.h"
#include <math.h>
double Expression::PI=3.1415926535897932384626433832795;
double Expression::e=2.7182818284590452353602874;


//---------------------------------------------------------------------------

#pragma package(smart_init)
Expression::Expression():
   exp(""),
   err(-99999999999)
{
}

Expression::Expression(const char * str):
   exp(str),
   err(-99999999999)
{
}

Expression::Expression(const Expression& other)
{

}

Expression::~Expression()
{

}
//---------------------------------------------------------------------------

string Expression::PutSpaces(){
  string newstr;
  for(int i=0;i<exp.length();i++){

     if (exp[i]==' ')
        continue;

     if (newstr.length()>0 && exp[i]=='(' && ((exp[newstr.length()-1]>='0' && exp[newstr.length()-1]<='9') || exp[newstr.length()-1]==')')){
        newstr+=" * ( ";
        continue;
     }

     if (IsOperator(exp[i]) || exp[i]=='(' || exp[i]==')'){
        if (newstr.length()>0 && newstr[newstr.length()-1]!=' ')
           newstr+=' ';
        newstr+=exp[i];
        newstr+=' ';
     }
     else
        newstr+=exp[i];
  }

  return newstr;

}

bool Expression::IsOperator(char op){
  return op=='+' || op=='-' || op=='/' || op=='*'  || op=='^';
}

bool Expression::IsFunction(string func){
  return func=="sin" || func=="cos"  || func=="sqrt" || func=="tan" || func=="log" || func=="ln";
}

bool Expression::IsVariable(string var){
  return var=="x" || var=="y"  || var=="z" || var=="pi" || var=="e" || var=="ans";
}

bool Expression::IsNumber(string num){
  bool pt=false;
  bool e=false;
      for(int i=0;i<num.size();i++){
         if ((num[i]<'0' || num[i]>'9') && num[i]!='_' && num[i]!=',' && num[i]!='E')
            return false;
         if  ((num[i]=='_' && (i!=0 || i==num.size()-1)) || (num[i]==',' && pt) || (num[i]=='E' && e))
            return false;
         if (num[i]==',')
            pt=true;
         if (num[i]=='E')
            e=true;
      }
  return true;
}

bool Expression::Match(char c, char d)
{
	  switch (c) {
		  case '(' : return (d==')');
		  case '[' : return (d==']');
		  case '{' : return (d=='}');
		  default  : return false;
	  }
}

bool Expression::Check()
{
       Stack <char> s;
       for(int i=0; i < exp.length(); i++)
       {
           char ch= exp[i];
           if( ch=='(' ||  ch=='[' ||  ch=='{' )
             s.Push(ch);
           else if ( ch==')' ||  ch==']' ||  ch=='}' )
           {
               if(s.IsEmpty())
                 return false;
               char par = s.Pop();
               if(!Match(par,ch))
                  return false;
           }
       }
       if(s.IsEmpty())
           return true;
       return false;
}

bool Expression::ValidExp(){

   if (!Check())
      return false;

   exp=PutSpaces();
   IteratorString it(exp);
   string bloco;

   if (!it.HasMoreElements())
         return false;
   if (IsOperator(it.Current()[0]))
      return false;

   while(it.HasMoreElements()){
      bloco=it.Current();

      if (IsOperator(it.Current()[0])){
         it.Next();
         if (!it.HasMoreElements())
            return false;
      }else
         it.Next();

      if  (bloco[0]=='(' && IsOperator(it.Current()[0]))
         return false;

      if ((IsOperator(bloco[0]) && (IsOperator(it.Current()[0]) || it.Current()[0]==')'))
                 || (bloco[0]=='(' && it.Current()[0]==')'))
         return false;

      if (bloco.size()==1 && (IsOperator(bloco[0]) || bloco[0]=='(' || bloco[0]==')'))
         continue;

      if (IsVariable(bloco))
         continue;

      if  (bloco[0]=='(' && IsOperator(it.Current()[0]))
         return false;

      if  (IsFunction(bloco) && it.Current()[0]!='(')
         return false;
      if  (IsFunction(bloco) && it.Current()[0]=='(')
         continue;

      if(!IsNumber(bloco))
         return false;
   }
   return true;
}

void Expression::InsertExp(string str){
   exp=str;
}


string Expression::ToPosFix(){
   string POSFIX;
   exp=PutSpaces();
   IteratorString it(exp);
   string bloco;

   while(it.HasMoreElements()){
      bloco=it.Current();
      it.Next();
      if (IsOperator(bloco[0]) || IsFunction(bloco))
         if (s.IsEmpty())
            s.Push(bloco);
         else{
            if (Priority(bloco)<=Priority(s.Peek()))
               while (!s.IsEmpty() && s.Peek()!="("){
                  if (POSFIX.size()>0)
                     POSFIX+=' ';
                  POSFIX+=s.Pop();
               }
            s.Push(bloco);
         }
      else if (bloco[0]=='(')
         s.Push(bloco);
      else if (bloco[0]==')'){
         while (s.Peek()!="("){
            if (POSFIX.size()>0)
               POSFIX+=' ';
            POSFIX+=s.Pop();
         }
         s.Pop();
      }else{
         if (POSFIX.size()>0)
            POSFIX+=' ';
         POSFIX+=bloco;
      }
   }
   while(!s.IsEmpty()){
      if (POSFIX.size()>0)
         POSFIX+=' ';
      POSFIX+=s.Pop();
   }

   return POSFIX;

}


double Expression::Value(double x,double y,double z,double ans){
   string POSFIX=ToPosFix();
   Stack <double> s;
   IteratorString it(POSFIX);
   AnsiString bloco;
   double num;

   while(it.HasMoreElements()){
      bloco=it.Current().c_str();
      it.Next();
      if (IsOperator(bloco[1]))
         switch(bloco[1]){
            case '+':
               s.Push(s.Pop()+s.Pop());
               break;
            case '-':
               num=s.Pop();
               s.Push(s.Pop()-num);
               break;
            case '*':
               s.Push(s.Pop()*s.Pop());
               break;
            case '/':
               num=s.Pop();
               if (num==0)
                  return err;
               s.Push(s.Pop()/num);
               break;
            case '^':
               num=s.Pop();
               s.Push(pow(s.Pop(),num));
               break;
         }
      else if (IsFunction(bloco.c_str())){
         if (bloco=="sin")
            s.Push(sin(s.Pop()));
         else if (bloco=="cos")
            s.Push(cos(s.Pop()));
         else if (bloco=="sqrt"){
            if (s.Peek()<0)
               return err;
            s.Push(sqrt(s.Pop()));
         }else if (bloco=="tan"){
            if ((PI/2.0)==abs(s.Peek()))
               return err;
            s.Push(tan(s.Pop()));
         }else if (bloco=="log"){
            if (s.Peek()<=0)
               return err;
            s.Push(log(s.Pop()));
         }else if (bloco=="ln"){
            if (s.Peek()<=0)
               return err;
            s.Push(log(s.Pop())/log(e));
         }
      }else{
         if (IsVariable(bloco.c_str())){
            if (bloco=="x")
               num=x;
            else if (bloco=="y")
               num=y;
            else if (bloco=="z")
               num=z;
            else if (bloco=="pi")
               num=PI;
            else if (bloco=="e")
               num=e;
            else if (bloco=="ans")
               num=ans;
         }
         else{
            if (bloco[1]=='_'){
               bloco.Delete(1,1);
               num=bloco.ToDouble();
               num=-num;
            }else
               num=bloco.ToDouble();
         }
         s.Push(num);
      }
   }
   return s.Pop();

}


int Expression::Priority(string str){

if (str[0] == '+' || str[0] == '-')
   return 1;

if (str[0] == '*' || str[0] == '/')
   return 2;

if (str[0] == '^')
   return 3;

if ( str == "cos" || str == "sin" || str =="sqrt")
   return 4;

return 0;
}
