//---------------------------------------------------------------------------

#ifndef ExpressionH
#define ExpressionH
#include "Stack.h"
//---------------------------------------------------------------------------
class Expression
{
   private:
        Stack <string> s;
        string exp;
   public:
           int err; //numero devolvido em caso de erro (Ex:Diviso por Zero)

        Expression();
        Expression(const char * str);
        Expression(const Expression& other);
        virtual ~Expression();
        virtual string PutSpaces(); //mate espaos entre os operadores
        virtual bool IsOperator(char op);
        virtual bool IsFunction(string func);
        virtual bool IsNumber(string num); //verifica se a string  um numero
        virtual bool IsVariable(string var);  //verifica se  uma variavel
        static  bool Match(char c, char d);
        virtual bool Check();
        virtual bool ValidExp(); //verifica se a expresso est sem erros
        virtual void InsertExp(string str); //introduz nova expresso
        virtual string ToPosFix();
        virtual double Value(double x=0,double y=0,double z=0,double ans=0); //valor da expresso
        virtual int Priority(string str); //prioridade dos operadores

   private:
        static double PI;
        static double e;
};
#endif
